// This file was generated by counterfeiter
package fake_process_tracker

import (
	"os/exec"
	"sync"

	"github.com/cloudfoundry-incubator/garden"
	"github.com/cloudfoundry-incubator/garden-linux/process_tracker"
)

type FakeProcessTracker struct {
	RunStub        func(uint32, *exec.Cmd, garden.ProcessIO, *garden.TTYSpec, process_tracker.Signaller) (garden.Process, error)
	runMutex       sync.RWMutex
	runArgsForCall []struct {
		arg1 uint32
		arg2 *exec.Cmd
		arg3 garden.ProcessIO
		arg4 *garden.TTYSpec
		arg5 process_tracker.Signaller
	}
	runReturns struct {
		result1 garden.Process
		result2 error
	}
	AttachStub        func(uint32, garden.ProcessIO) (garden.Process, error)
	attachMutex       sync.RWMutex
	attachArgsForCall []struct {
		arg1 uint32
		arg2 garden.ProcessIO
	}
	attachReturns struct {
		result1 garden.Process
		result2 error
	}
	RestoreStub        func(processID uint32, signaller process_tracker.Signaller)
	restoreMutex       sync.RWMutex
	restoreArgsForCall []struct {
		processID uint32
		signaller process_tracker.Signaller
	}
	ActiveProcessesStub        func() []garden.Process
	activeProcessesMutex       sync.RWMutex
	activeProcessesArgsForCall []struct{}
	activeProcessesReturns     struct {
		result1 []garden.Process
	}
}

func (fake *FakeProcessTracker) Run(arg1 uint32, arg2 *exec.Cmd, arg3 garden.ProcessIO, arg4 *garden.TTYSpec, arg5 process_tracker.Signaller) (garden.Process, error) {
	fake.runMutex.Lock()
	fake.runArgsForCall = append(fake.runArgsForCall, struct {
		arg1 uint32
		arg2 *exec.Cmd
		arg3 garden.ProcessIO
		arg4 *garden.TTYSpec
		arg5 process_tracker.Signaller
	}{arg1, arg2, arg3, arg4, arg5})
	fake.runMutex.Unlock()
	if fake.RunStub != nil {
		return fake.RunStub(arg1, arg2, arg3, arg4, arg5)
	} else {
		return fake.runReturns.result1, fake.runReturns.result2
	}
}

func (fake *FakeProcessTracker) RunCallCount() int {
	fake.runMutex.RLock()
	defer fake.runMutex.RUnlock()
	return len(fake.runArgsForCall)
}

func (fake *FakeProcessTracker) RunArgsForCall(i int) (uint32, *exec.Cmd, garden.ProcessIO, *garden.TTYSpec, process_tracker.Signaller) {
	fake.runMutex.RLock()
	defer fake.runMutex.RUnlock()
	return fake.runArgsForCall[i].arg1, fake.runArgsForCall[i].arg2, fake.runArgsForCall[i].arg3, fake.runArgsForCall[i].arg4, fake.runArgsForCall[i].arg5
}

func (fake *FakeProcessTracker) RunReturns(result1 garden.Process, result2 error) {
	fake.RunStub = nil
	fake.runReturns = struct {
		result1 garden.Process
		result2 error
	}{result1, result2}
}

func (fake *FakeProcessTracker) Attach(arg1 uint32, arg2 garden.ProcessIO) (garden.Process, error) {
	fake.attachMutex.Lock()
	fake.attachArgsForCall = append(fake.attachArgsForCall, struct {
		arg1 uint32
		arg2 garden.ProcessIO
	}{arg1, arg2})
	fake.attachMutex.Unlock()
	if fake.AttachStub != nil {
		return fake.AttachStub(arg1, arg2)
	} else {
		return fake.attachReturns.result1, fake.attachReturns.result2
	}
}

func (fake *FakeProcessTracker) AttachCallCount() int {
	fake.attachMutex.RLock()
	defer fake.attachMutex.RUnlock()
	return len(fake.attachArgsForCall)
}

func (fake *FakeProcessTracker) AttachArgsForCall(i int) (uint32, garden.ProcessIO) {
	fake.attachMutex.RLock()
	defer fake.attachMutex.RUnlock()
	return fake.attachArgsForCall[i].arg1, fake.attachArgsForCall[i].arg2
}

func (fake *FakeProcessTracker) AttachReturns(result1 garden.Process, result2 error) {
	fake.AttachStub = nil
	fake.attachReturns = struct {
		result1 garden.Process
		result2 error
	}{result1, result2}
}

func (fake *FakeProcessTracker) Restore(processID uint32, signaller process_tracker.Signaller) {
	fake.restoreMutex.Lock()
	fake.restoreArgsForCall = append(fake.restoreArgsForCall, struct {
		processID uint32
		signaller process_tracker.Signaller
	}{processID, signaller})
	fake.restoreMutex.Unlock()
	if fake.RestoreStub != nil {
		fake.RestoreStub(processID, signaller)
	}
}

func (fake *FakeProcessTracker) RestoreCallCount() int {
	fake.restoreMutex.RLock()
	defer fake.restoreMutex.RUnlock()
	return len(fake.restoreArgsForCall)
}

func (fake *FakeProcessTracker) RestoreArgsForCall(i int) (uint32, process_tracker.Signaller) {
	fake.restoreMutex.RLock()
	defer fake.restoreMutex.RUnlock()
	return fake.restoreArgsForCall[i].processID, fake.restoreArgsForCall[i].signaller
}

func (fake *FakeProcessTracker) ActiveProcesses() []garden.Process {
	fake.activeProcessesMutex.Lock()
	fake.activeProcessesArgsForCall = append(fake.activeProcessesArgsForCall, struct{}{})
	fake.activeProcessesMutex.Unlock()
	if fake.ActiveProcessesStub != nil {
		return fake.ActiveProcessesStub()
	} else {
		return fake.activeProcessesReturns.result1
	}
}

func (fake *FakeProcessTracker) ActiveProcessesCallCount() int {
	fake.activeProcessesMutex.RLock()
	defer fake.activeProcessesMutex.RUnlock()
	return len(fake.activeProcessesArgsForCall)
}

func (fake *FakeProcessTracker) ActiveProcessesReturns(result1 []garden.Process) {
	fake.ActiveProcessesStub = nil
	fake.activeProcessesReturns = struct {
		result1 []garden.Process
	}{result1}
}

var _ process_tracker.ProcessTracker = new(FakeProcessTracker)
